'' =================================================================================================
''
''   File....... jm_textbuf.spin
''   Purpose....
''   Author..... Jon "JonnyMac" McPhalen
''               Copyright (c) 2015 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started....
''   Updated.... 25 MAR 2015
''
'' =================================================================================================


con

  BUF_SIZE = 80 + 1                                              ' 80 chars + terminating 0 


var

  byte  buffer[BUF_SIZE]                                         ' buffer
  byte  bidx                                                     ' buffer index (next char)


pub reset

'' Clears buffer and resets buffer index

  bytefill(@buffer, 0, BUF_SIZE + 1)                             ' reset buffer and 


pub putc(c)

'' Add character to end of buffer

  if (bidx < BUF_SIZE)                                           ' if space in buffer
    buffer[bidx++] := c                                          '  add new character


pub puts(p_str)

'' Add string to end of buffer

  repeat strsize(p_str)                                          ' loop through p_str
    putc(byte[p_str++])                                          '   add char if space available        


pub copy(p_str) | n

'' Copies string at p_str to buffer

  n := strsize(p_str)                                            ' number of bytes in source string

  if (n < BUF_SIZE)                                              ' will it fit?
    reset                                                        ' yes, clear buffer
    bytemove(@buffer, p_str, n)                                  ' copy new string into buffer
    bidx := n                                                    ' update buffer index
    return true                                                  ' report success

  return false

   
pub len

'' Returns length of buffer (as string)

  return strsize(@buffer)


pub ucase | idx

'' Converts alpha characters in buffer to upper case
                    
  repeat idx from 0 to bidx
    if ((buffer[idx] => "a") and (buffer[idx] =< "z"))
      buffer[idx] -= 32


pub lcase | idx

'' Converts alpha characters in buffer to lower case
                    
  repeat idx from 0 to bidx
    if ((buffer[idx] => "A") and (buffer[idx] =< "Z"))
      buffer[idx] += 32


pub truncate(n)

'' Sets length of buffer to n
'' -- only if buffer longer than n

  if ((n => 0) and (n < bidx))
    buffer[n] := 0
    bidx := 0
    return true

  return false

      
pub addr

'' Provides buffer address for external string methods

  return @buffer
   
  
dat { license }

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}